commit bbfe973c526bf8e42a018f9d360a5ff7414d862f
Author: freddy77 <freddy77>
Date:   Sat Jul 31 11:31:15 2010 +0000

    fix bcp_bind with vartype == 0

diff --git a/ChangeLog b/ChangeLog
index dd56276..ac2f660 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sat Jul 31 13:31:08 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/bcp.c: fix bcp_bind with vartype == 0
+
 Sat Jul 31 13:20:26 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsthread.h: allow mutex declaration inside structures
 
@@ -2799,4 +2802,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3104 2010/07/31 11:20:34 freddy77 Exp $
+$Id: ChangeLog,v 1.3105 2010/07/31 11:31:15 freddy77 Exp $
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index c0c4a30..6c2dbaa 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -62,7 +62,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.194 2010/02/12 10:16:17 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.195 2010/07/31 11:31:16 freddy77 Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -2386,7 +2386,7 @@ _bcp_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset)
 	TDS_SMALLINT si;
 	TDS_INT li;
 	TDS_INT desttype;
-	int collen;
+	int collen, coltype;
 	int data_is_null;
 	int bytes_read;
 	int converted_data_size;
@@ -2442,10 +2442,12 @@ _bcp_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset)
 		}
 	}
 
-	/* Fixed Length data - this overrides anything else specified */
+	desttype = tds_get_conversion_type(bindcol->column_type, bindcol->column_size);
 
-	if (is_fixed_type(bindcol->column_bindtype)) {
-		collen = tds_get_size_by_type(bindcol->column_bindtype);
+	/* Fixed Length data - this overrides anything else specified */
+	coltype = bindcol->column_bindtype == 0 ? desttype : bindcol->column_bindtype;
+	if (is_fixed_type(coltype)) {
+		collen = tds_get_size_by_type(coltype);
 	}
 
 	/* read the data, finally */
@@ -2466,10 +2468,8 @@ _bcp_get_col_data(TDSBCPINFO *bcpinfo, TDSCOLUMN *bindcol, int offset)
 		bindcol->bcp_column_data->datalen = 0;
 		bindcol->bcp_column_data->is_null = 1;
 	} else {
-		desttype = tds_get_conversion_type(bindcol->column_type, bindcol->column_size);
-
 		if ((converted_data_size =
-		     dbconvert(dbproc, bindcol->column_bindtype,
+		     dbconvert(dbproc, coltype,
 			       (BYTE *) dataptr, collen,
 			       desttype, bindcol->bcp_column_data->data, bindcol->column_size)) == FAIL) {
 			return TDS_FAIL;

